# we don't want to provide private python extension libs
%{?filter_setup:
%filter_provides_in %{python_sitearch}/.*\.so$
%filter_setup
}

#define _version_suffix -9473

Name:           spice-gtk
Version:        0.11
Release:        11%{?dist}.1
Summary:        A GTK+ widget for SPICE clients

Group:          System Environment/Libraries
License:        LGPLv2+
URL:            http://spice-space.org/page/Spice-Gtk
Source0:        http://www.spice-space.org/download/gtk/%{name}-%{version}.tar.bz2
Patch1:         0001-usbredir-Check-for-existing-usb-channels-after-libus.patch
Patch2:         0002-Fix-incorrect-array-size-check.patch
Patch3:         0003-Use-given-color-depth-in-monitor-configuration.patch
Patch4:         0004-Fix-non-semi-seamless-migration-in-spicy.patch
Patch5:         0005-Improve-spice_main_set_display_enabled.patch
Patch6:         0006-Notify-agent-connected-property-change.patch
Patch7:         0007-Do-not-grab-display-widget.patch
Patch8:         0008-Hide-cursor-when-it-is-on-a-different-screen-in-serv.patch
Patch9:         0009-Handle-controller-CAD.patch
Patch10:        0010-Fix-cursor-not-being-shown.patch
Patch11:        0011-Always-release-shm-of-primary-surfaces.patch
Patch12:        0012-usb-acl-helper-add-a-missing-break.patch
Patch13:        0013-usb-device-widget-Call-set_active-on-the-toggle_butt.patch
Patch14:        0014-Be-more-tolerant-on-NULL-arrays.patch
Patch15:        0015-session-take-pubkey-reference-in-setter.patch
Patch16:        0016-mjpeg-fix-blue-tinted-video-stream-with-old-server.patch
Patch17:        0017-widget-fix-invalid-memory-ref-after-channel-is-distr.patch
# Patch cherry-picked from upstream, rhbz #787449
Patch18:        0018-controller-add-support-for-DISABLE_EFFECTS-and-COLOR.patch
# Patch cherry-picked from upstream, rhbz #807296
Patch19:        0019-controller-handle-USB-redirection-messages.patch
Patch20:        0020-Handle-grab-broken-event.patch
Patch21:        0021-Fix-crash-when-closing-while-recording.patch
Patch22:        0022-agent-avoid-use-of-alloca-for-sending-large-msg.patch
Patch23:        0023-Fix-cursor-hide-not-hiding-in-some-cases.patch
Patch24:        0024-gtk-scroll-event-are-not-received-with-recent-gtk.patch
Patch25:        0025-Set-new-cert-subject-when-switching-host.patch
Patch26:        0026-Clear-cache-and-glz-dictionnary-on-switch-host.patch
Patch27:        0027-video-streaming-add-support-for-frames-of-different-sizes.patch
Patch28:        0028-Reset-correctly-channel-capabilities.patch
Patch29:        0029-session-correctly-track-main-channel.patch
Patch30:        0030-CVE-2012-3524.patch

BuildRequires: intltool
BuildRequires: gtk2-devel >= 2.14
BuildRequires: usbredir-devel >= 0.4
BuildRequires: libusb1-devel >= 1.0.9
BuildRequires: libgudev1-devel
BuildRequires: pixman-devel openssl-devel libjpeg-devel
BuildRequires: celt051-devel pulseaudio-libs-devel
BuildRequires: pygtk2-devel python-devel zlib-devel
BuildRequires: cyrus-sasl-devel
BuildRequires: libcacard-devel
BuildRequires: libacl-devel
BuildRequires: polkit-devel
BuildRequires: usbutils
# needed for bz 799112
BuildRequires: spice-protocol
# Hack because of bz #613466
BuildRequires: libtool
Requires: spice-glib%{?_isa} = %{version}-%{release}
Requires: gtk2 >= 2.18.9-10

ExclusiveArch: %{ix86} x86_64

%description
Client libraries for SPICE desktop servers.

%package devel
Summary: Development files to build GTK2 applications with spice-gtk-2.0
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: spice-glib-devel%{?_isa} = %{version}-%{release}
Requires: pkgconfig
Requires: gtk2-devel

%description devel
spice-client-gtk-2.0 provides a SPICE viewer widget for GTK2.

Libraries, includes, etc. to compile with the spice-gtk2 libraries

%package -n spice-glib
Summary: A GObject for communicating with Spice servers
Group: Development/Libraries
# Ensure we have a new enough libusb for usbredir
Requires: libusb1 >= 1.0.9

%description -n spice-glib
spice-client-glib-2.0 is a SPICE client library for GLib2.

%package -n spice-glib-devel
Summary: Development files to build Glib2 applications with spice-glib-2.0
Group: Development/Libraries
Requires: spice-glib%{?_isa} = %{version}-%{release}
Requires: pkgconfig
Requires: glib2-devel
Requires: spice-protocol

%description -n spice-glib-devel
spice-client-glib-2.0 is a SPICE client library for GLib2.

Libraries, includes, etc. to compile with the spice-glib-2.0 libraries

%package python
Summary: Python bindings for the spice-gtk-2.0 library
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description python
SpiceClientGtk module provides a SPICE viewer widget for GTK2.

A module allowing use of the spice-gtk-2.0 widget from python

%package tools
Summary: Spice-gtk tools
Group: Applications/Internet
Requires: %{name}%{?_isa} = %{version}-%{release}

%description tools
Simple clients for interacting with SPICE servers.
spicy is a client to a SPICE desktop server.
snappy is a tool to capture screen-shots of a SPICE desktop.

%prep
%setup -q -n spice-gtk-%{version}%{?_version_suffix} -c

if [ -n '%{?_version_suffix}' ]; then
  mv spice-gtk-%{version}%{?_version_suffix} spice-gtk-%{version}
fi

pushd spice-gtk-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1

find . -name '*.stamp' | xargs touch

popd

%build
cd spice-gtk-%{version}
%configure --disable-gtk-doc --with-gtk=2.0 --disable-introspection --with-usb-acl-helper-dir=%{_libexecdir}/spice-gtk-%{_arch}/
make %{?_smp_mflags}
cd ..

%install
cd spice-gtk-%{version}
make install DESTDIR=%{buildroot}
rm -f %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.a
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.la
%find_lang %{name}
cd ..

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post -n spice-glib -p /sbin/ldconfig
%postun -n spice-glib -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc spice-gtk-%{version}/AUTHORS
%doc spice-gtk-%{version}/COPYING
%doc spice-gtk-%{version}/README
%doc spice-gtk-%{version}/NEWS
%{_libdir}/libspice-client-gtk-2.0.so.*

%files devel
%defattr(-,root,root,-)
%{_libdir}/libspice-client-gtk-2.0.so
%{_includedir}/spice-client-gtk-2.0
%{_libdir}/pkgconfig/spice-client-gtk-2.0.pc

%files -n spice-glib -f spice-gtk-%{version}/%{name}.lang
%defattr(-,root,root,-)
%{_libdir}/libspice-client-glib-2.0.so.*
%{_libdir}/libspice-controller.so.*
%{_libexecdir}/spice-gtk-%{_arch}/spice-client-glib-usb-acl-helper
%{_datadir}/polkit-1/actions/org.spice-space.lowlevelusbaccess.policy

%files -n spice-glib-devel
%defattr(-,root,root,-)
%{_libdir}/libspice-client-glib-2.0.so
%{_libdir}/libspice-controller.so
%{_includedir}/spice-client-glib-2.0
%{_includedir}/spice-controller/*
%{_libdir}/pkgconfig/spice-client-glib-2.0.pc
%{_libdir}/pkgconfig/spice-controller.pc
%{_datadir}/vala/vapi/spice-protocol.vapi
%doc %{_datadir}/gtk-doc/html/*

%files python
%defattr(-,root,root,-)
%{_libdir}/python*/site-packages/SpiceClientGtk.so

%files tools
%defattr(-,root,root,-)
%{_bindir}/snappy
%{_bindir}/spicy
%{_bindir}/spicy-stats

%changelog
* Tue Sep 11 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.11-11.el6_3.1
- Fix version for Z-stream
  Related: rhbz#854823

* Mon Sep 10 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.11-12
- Add patch fixing CVE-2012-3524
  Resolves: rhbz#854823

* Wed May 23 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-11
- Correctly track main channel, fix crash in some migration cases
  Resolves: rhbz#823874

* Thu May 17 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-10
- Fix channel caps not being reset correctly, and causing migration to fail
  Resolves: rhbz#821795

* Sun May 6 2012 Yonit Halperin     <yhalperi@redhat.com> - 0.11-9
- Introduce sized video frames, for fixing glitches in youtube movies.
  Resolves: rhbz#815426

* Mon Apr 16 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-8
- Fix switch-host migration error with ssl channels.
  Resolves: rhbz#802574

* Tue Apr 10 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-7
- Handle grab-broken event
  Resolves: rhbz#807292
- Fix segfault with large clipboard copy-paste
  Resolves: rhbz#809145
- Fix cursor not hidden
  Resolves: rhbz#810588
- Fix segfault when closing while recording
  Resolves: rhbz#810247
- Add USB support to controller
  Resolves: rhbz#807296
- Add WAN support to controller
  Resolves: rhbz#787449

* Tue Apr 03 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-6
- Fix blue-tinted video with old Spice server
  Resolves: rhbz#807389
- Fix segfault during switch-host migration
  Resolves: rhbz#807410
- Fix switch-host migration failure with SSL
  Resolves: rhbz#802574
- Fix crash during migration while playing video
  Resolves: rhbz#808567
- Requires gtk2 >= 2.18.9-10
  Resolves: rhbz#809033

* Thu Mar 22 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-5
- Fix memory leak when resizing guest
  Resolves: rhbz#805641

* Wed Mar 21 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-4
- Fix cursor is displayed on each guest screen when mouse is in server mode
  Resolves: rhbz#804308

* Wed Mar 21 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-3
- Fix cursor is displayed on each guest screen when mouse is in server mode
  Resolves: rhbz#804308
- Fix --spice-color-depth=16 does not seem to work.
  Resolves: rhbz#802898
- Fix cannot leave full-screen when mouse is grabbed in server mode mouse
  Resolves: rhbz#804307

* Wed Mar 14 2012 Hans de Goede <hdegoede@redhat.com> - 0.11-2
- Fix a crash triggered when trying to view a usbredir enabled vm from
  virt-manager
  Related: rhbz#758100

* Thu Mar 08 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-1
- Rebase to 0.11 upstream release
  Related: rhbz#773642

* Wed Mar 07 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.6-3
- Add back spice-protocol BuildRequires to help some deps magic happen.
  Resolves: #799112

* Thu Mar 06 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.6-2
- spice-client-glib-devel requires spice-protocol.
  Resolves: #799112
- seam-less migration fix.

* Thu Mar 01 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.6-1
- Add foreign menu support.
  Related: rhbz#773642

* Fri Feb 24 2012 Hans de Goede <hdegoede@redhat.com> - 0.10-1
- Rebase to 0.10 upstream release
  Related: rhbz#773642

* Tue Jan 31 2012 Hans de Goede <hdegoede@redhat.com> - 0.9-1
- Rebase to 0.9 upstream release
  Related: rhbz#773642

* Wed Jan 25 2012 Hans de Goede <hdegoede@redhat.com> - 0.8-1
- Rebase to 0.8 upstream release
  Resolves: rhbz#773642
- This release add support for usbredirection
  Resolves: rhbz#758100
- This release fixes spice-gtk crashing on machines with no soundcard
  Resolves: rhbz#772118

* Mon Jul 18 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-2
- Set release to -2 so that the EPEL package gets upgraded
- Related: rhbz#708417

* Mon Jul 18 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-1
- Added spice-gtk-0.6-add-generated-files.patch to be able to build without
  perl-Text-CSV
- Initial import of spice-gtk in RHEL CVS based on the EPEL .spec
- Related: rhbz#708417

* Fri May 27 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-1
- Initial EPEL release based on the rawhide .spec cleaned up from the parts
  that are not useful for EPEL (because the needed dependencies are not available)

* Wed May 25 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-1
- Upstream release 0.6

* Tue Mar  1 2011 Hans de Goede <hdegoede@redhat.com> - 0.5-6
- Fix spice-glib requires in .pc file (#680314)

* Fri Feb 11 2011 Matthias Clasen <mclasen@redhat.com> - 0.5-5
- Fix build against glib 2.28

* Thu Feb 10 2011 Matthias Clasen <mclasen@redhat.com> - 0.5-4
- Rebuild against newer gtk

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Feb  2 2011 Matthias Clasen <mclasen@redhat.com> - 0.5-2
- Rebuild against newer gtk

* Thu Jan 27 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5-1
- Upstream release 0.5

* Fri Jan 14 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4-2
- Add support for parallel GTK3 build

* Mon Jan 10 2011 Dan Horák <dan[at]danny.cz> - 0.4-2
- add ExclusiveArch as only x86 is supported

* Sun Jan 09 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.4-1
- Upstream release 0.4
- Initial release (#657403)

* Thu Nov 25 2010 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.1.0-1
- Initial packaging
